package com.bcxin.identity.domains.services;

import com.bcxin.identity.domains.services.commandResult.PrepareResetPasswordCommandResult;
import com.bcxin.identity.domains.services.commands.*;

public interface IdentityUserService {
    SignInCommand.SignInCommandResult signIn(SignInCommand command);

    ChangePasswordCommand.ChangePasswordCommandResult changePassword(ChangePasswordCommand command);

    void signUp(SignUpCommand command);

    void dispatch(WechatBindCommand command);

    SignInCommand.SignInCommandResult dispatch(WechatSignInCommand command);

    SignInCommand.SignInCommandResult dispatch(WechatMiniSignInCommand command);

    void dispatch(UpdateIdentityBasicCommand command);

    void dispatch(WechatUnBindCommand command);

    /**
     * description：判断是否绑定微信unionid
     * author：linchunpeng
     * date：2023/10/12
     */
    boolean dispatch(WechatCheckUnionIdCommand command);

    PrepareResetPasswordCommandResult dispatch(PrepareResetPasswordCommand command);

    void dispatch(ResetPasswordCommand command);

    PrepareResetPasswordCommandResult getUserMobile(PrepareResetPasswordCommand command);

    void dispatch(ResetPasswordCommandAdmin command);

    void resetPasswordCheckCode(ResetPasswordCommand command);

    void changeUserName(ChangeUserNameCommand command);
}
